Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/ScatterPlotView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/ScatterPlotView.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/ScatterPlotView.cs	(revision 3462)
@@ -84,14 +84,15 @@
       : this() {
       Content = dataAnalysisSolution;
+      UpdateChart();
     }
 
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.ModelChanged += new EventHandler(Content_ModelChanged);
+      Content.EstimatedValuesChanged += new EventHandler(Content_EstimatedValuesChanged);
       Content.ProblemDataChanged += new EventHandler(Content_ProblemDataChanged);
     }
     protected override void DeregisterContentEvents() {
       base.DeregisterContentEvents();
-      Content.ModelChanged -= new EventHandler(Content_ModelChanged);
+      Content.EstimatedValuesChanged -= new EventHandler(Content_EstimatedValuesChanged);
       Content.ProblemDataChanged -= new EventHandler(Content_ProblemDataChanged);
     }
@@ -99,9 +100,9 @@
 
     void Content_ProblemDataChanged(object sender, EventArgs e) {
-      OnContentChanged();
-    }
-
-    void Content_ModelChanged(object sender, EventArgs e) {
-      OnContentChanged();
+      UpdateChart();
+    }
+
+    void Content_EstimatedValuesChanged(object sender, EventArgs e) {
+      UpdateSeries();
     }
 
@@ -127,30 +128,33 @@
 
     private void UpdateSeries() {
-      string targetVariableName = Content.ProblemData.TargetVariable.Value;
-      Dataset dataset = Content.ProblemData.Dataset;
-      int trainingStart = Content.ProblemData.TrainingSamplesStart.Value;
-      int trainingEnd = Content.ProblemData.TrainingSamplesEnd.Value;
-      int testStart = Content.ProblemData.TestSamplesStart.Value;
-      int testEnd = Content.ProblemData.TestSamplesEnd.Value;
-      if (this.chart.Series[ALL_SERIES].Points.Count > 0)
-        this.chart.Series[ALL_SERIES].Points.DataBindXY(Content.EstimatedValues.ToArray(), "",
-          dataset[targetVariableName], "");
-      if (this.chart.Series[TRAINING_SERIES].Points.Count > 0)
-        this.chart.Series[TRAINING_SERIES].Points.DataBindXY(Content.EstimatedTrainingValues.ToArray(), "",
-          dataset.GetVariableValues(targetVariableName, trainingStart, trainingEnd), "");
-      if (this.chart.Series[TEST_SERIES].Points.Count > 0)
-        this.chart.Series[TEST_SERIES].Points.DataBindXY(Content.EstimatedTestValues.ToArray(), "",
-          dataset.GetVariableValues(targetVariableName, testStart, testEnd), "");
-
-      double max = Math.Max(Content.EstimatedValues.Max(), dataset.GetMax(targetVariableName));
-      double min = Math.Min(Content.EstimatedValues.Min(), dataset.GetMin(targetVariableName));
-
-      max = Math.Ceiling(max) * 1.2;
-      min = Math.Floor(min) * 0.8;
-
-      this.chart.ChartAreas[0].AxisX.Maximum = max;
-      this.chart.ChartAreas[0].AxisX.Minimum = min;
-      this.chart.ChartAreas[0].AxisY.Maximum = max;
-      this.chart.ChartAreas[0].AxisY.Minimum = min;
+      if (InvokeRequired) Invoke((Action)UpdateSeries);
+      else {
+        string targetVariableName = Content.ProblemData.TargetVariable.Value;
+        Dataset dataset = Content.ProblemData.Dataset;
+        int trainingStart = Content.ProblemData.TrainingSamplesStart.Value;
+        int trainingEnd = Content.ProblemData.TrainingSamplesEnd.Value;
+        int testStart = Content.ProblemData.TestSamplesStart.Value;
+        int testEnd = Content.ProblemData.TestSamplesEnd.Value;
+        if (this.chart.Series[ALL_SERIES].Points.Count > 0)
+          this.chart.Series[ALL_SERIES].Points.DataBindXY(Content.EstimatedValues.ToArray(), "",
+            dataset[targetVariableName], "");
+        if (this.chart.Series[TRAINING_SERIES].Points.Count > 0)
+          this.chart.Series[TRAINING_SERIES].Points.DataBindXY(Content.EstimatedTrainingValues.ToArray(), "",
+            dataset.GetVariableValues(targetVariableName, trainingStart, trainingEnd), "");
+        if (this.chart.Series[TEST_SERIES].Points.Count > 0)
+          this.chart.Series[TEST_SERIES].Points.DataBindXY(Content.EstimatedTestValues.ToArray(), "",
+            dataset.GetVariableValues(targetVariableName, testStart, testEnd), "");
+
+        double max = Math.Max(Content.EstimatedValues.Max(), dataset.GetMax(targetVariableName));
+        double min = Math.Min(Content.EstimatedValues.Min(), dataset.GetMin(targetVariableName));
+
+        max = Math.Ceiling(max) * 1.2;
+        min = Math.Floor(min) * 0.8;
+
+        this.chart.ChartAreas[0].AxisX.Maximum = max;
+        this.chart.ChartAreas[0].AxisX.Minimum = min;
+        this.chart.ChartAreas[0].AxisY.Maximum = max;
+        this.chart.ChartAreas[0].AxisY.Minimum = min;
+      }
     }
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs	(revision 3462)
@@ -44,5 +44,5 @@
     public new SymbolicRegressionSolution Content {
       get { return (SymbolicRegressionSolution)base.Content; }
-      set {        base.Content = value;       }
+      set { base.Content = value; }
     }
 
@@ -58,6 +58,24 @@
     }
 
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ModelChanged += new EventHandler(Content_ModelChanged);
+    }
+
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+      Content.ModelChanged -= new EventHandler(Content_ModelChanged);
+    }
+
+    void Content_ModelChanged(object sender, EventArgs e) {
+      UpdateTreeChart();
+    }
+
     protected override void OnContentChanged() {
       base.OnContentChanged();
+      UpdateTreeChart();
+    }
+
+    private void UpdateTreeChart() {
       var simplifier = new SymbolicSimplifier();
       var simplifiedTree = simplifier.Simplify(Content.Model.SymbolicExpressionTree);
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs	(revision 3462)
@@ -57,6 +57,25 @@
     }
 
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ModelChanged += new EventHandler(Content_ModelChanged);
+    }
+
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+      Content.ModelChanged -= new EventHandler(Content_ModelChanged);
+    }
+
+    void Content_ModelChanged(object sender, EventArgs e) {
+      UpdateTreeChart();
+    }
+
     protected override void OnContentChanged() {
       base.OnContentChanged();
+      UpdateTreeChart();
+    }
+
+    private void UpdateTreeChart() {
       viewHost.Content = Content.Model.SymbolicExpressionTree;
     }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs	(revision 3462)
@@ -35,17 +35,5 @@
   [Item("DataAnalysisSolution", "Represents a solution for a data analysis problem which can be visualized in the GUI.")]
   [StorableClass]
-  public class DataAnalysisSolution : Item {
-    [Storable]
-    private IModel model;
-    public IModel Model {
-      get { return model; }
-      set {
-        if (model != value) {
-          model = value;
-          OnModelChanged();
-        }
-      }
-    }
-
+  public abstract class DataAnalysisSolution : Item {
     [Storable]
     private DataAnalysisProblemData problemData;
@@ -58,35 +46,17 @@
           problemData = value;
           RegisterProblemDataEvents();
-          OnProblemDataChanged();
+          OnProblemDataChanged(EventArgs.Empty);
         }
       }
     }
 
-    private List<double> estimatedValues;
-    public IEnumerable<double> EstimatedValues {
-      get {
-        return estimatedValues;
-      }
-    }
+    public abstract IEnumerable<double> EstimatedValues { get; }
+    public abstract IEnumerable<double> EstimatedTrainingValues { get; }
+    public abstract IEnumerable<double> EstimatedTestValues { get; }
 
-    private List<double> estimatedTrainingValues;
-    public IEnumerable<double> EstimatedTrainingValues {
-      get {
-        return estimatedTrainingValues;
-      }
-    }
-
-    private List<double> estimatedTestValues;
-    public IEnumerable<double> EstimatedTestValues {
-      get {
-        return estimatedTestValues;
-      }
-    }
-
-    public DataAnalysisSolution() : base() { }
-    public DataAnalysisSolution(DataAnalysisProblemData problemData, IModel model)
+    protected DataAnalysisSolution() : base() { }
+    protected DataAnalysisSolution(DataAnalysisProblemData problemData)
       : this() {
       this.problemData = problemData;
-      this.model = model;
       Initialize();
     }
@@ -98,30 +68,9 @@
     private void Initialize() {
       if (problemData != null) RegisterProblemDataEvents();
-      if (problemData != null && model != null) RecalculateEstimatedValues();
-    }
-
-    private void RecalculateEstimatedValues() {
-      estimatedValues = GetEstimatedValues(0, problemData.Dataset.Rows).ToList();
-      int nTrainingValues = problemData.TrainingSamplesEnd.Value - problemData.TrainingSamplesStart.Value;
-      estimatedTrainingValues = estimatedValues.Skip(problemData.TrainingSamplesStart.Value).Take(nTrainingValues).ToList();
-      int nTestValues = problemData.TestSamplesEnd.Value - problemData.TestSamplesStart.Value;
-      estimatedTestValues = estimatedValues.Skip(problemData.TestSamplesStart.Value).Take(nTestValues).ToList();
-    }
-
-    private IEnumerable<double> GetEstimatedValues(int start, int end) {
-      double[] xs = new double[ProblemData.InputVariables.Count];
-      for (int row = 0; row < ProblemData.Dataset.Rows; row++) {
-        for (int i = 0; i < xs.Length; i++) {
-          var variableIndex = ProblemData.Dataset.GetVariableIndex(ProblemData.InputVariables[i].Value);
-          xs[i] = ProblemData.Dataset[row, variableIndex];
-        }
-        yield return model.GetValue(xs);
-      }
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      DataAnalysisSolution clone = new DataAnalysisSolution();
-      cloner.RegisterClonedObject(this, clone);
-      clone.model = (IModel)cloner.Clone(model);
+      DataAnalysisSolution clone = (DataAnalysisSolution)base.Clone(cloner);
+      // don't clone the problem data!
       clone.problemData = problemData;
       clone.Initialize();
@@ -130,28 +79,27 @@
 
     #region Events
-    public event EventHandler ModelChanged;
-    private void OnModelChanged() {
-      RecalculateEstimatedValues();
-      var changed = ModelChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-    public event EventHandler ProblemDataChanged;
-    private void OnProblemDataChanged() {
-      RecalculateEstimatedValues();
-      var changed = ProblemDataChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    private void RegisterProblemDataEvents() {
+    protected virtual void RegisterProblemDataEvents() {
       ProblemData.ProblemDataChanged += new EventHandler(ProblemData_Changed);
     }
-    private void DeregisterProblemDataEvents() {
+    protected virtual void DeregisterProblemDataEvents() {
       ProblemData.ProblemDataChanged += new EventHandler(ProblemData_Changed);
     }
 
     private void ProblemData_Changed(object sender, EventArgs e) {
-      OnProblemDataChanged();
+      OnProblemDataChanged(EventArgs.Empty);
+    }
+
+    public event EventHandler ProblemDataChanged;
+    protected virtual void OnProblemDataChanged(EventArgs e) {
+      var listeners = ProblemDataChanged;
+      if (listeners != null)
+        listeners(this, e);
+    }
+
+    public event EventHandler EstimatedValuesChanged;
+    protected virtual void OnEstimatedValuesChanged(EventArgs e) {
+      var listeners = EstimatedValuesChanged;
+      if (listeners != null)
+        listeners(this, e);
     }
     #endregion
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleMSEEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleMSEEvaluator.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleMSEEvaluator.cs	(revision 3462)
@@ -73,5 +73,5 @@
                      select values[row, ORIGINAL_INDEX];
       var estimated = from row in Enumerable.Range(0, values.Rows)
-                      select values[row, ORIGINAL_INDEX];
+                      select values[row, ESTIMATION_INDEX];
       return Calculate(original, estimated);
     }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleNMSEEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleNMSEEvaluator.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleNMSEEvaluator.cs	(revision 3462)
@@ -24,4 +24,5 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj	(revision 3462)
@@ -98,13 +98,16 @@
     <Compile Include="Evaluators\SimpleVarianceAccountedForEvaluator.cs" />
     <Compile Include="HeuristicLabProblemsDataAnalysisPlugin.cs" />
-    <Compile Include="Interfaces\IModel.cs" />
     <Compile Include="MatrixExtensions.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Statistics.cs" />
     <Compile Include="Symbolic\ArithmeticExpressionGrammar.cs" />
-    <Compile Include="Symbolic\SimpleArithmeticExpressionEvaluator.cs" />
+    <Compile Include="Symbolic\ISymbolicExpressionTreeInterpreter.cs" />
+    <Compile Include="Symbolic\SimpleArithmeticExpressionInterpreter.cs" />
     <Compile Include="Symbolic\SymbolicSimplifier.cs" />
+    <Compile Include="Symbolic\Symbols\Addition.cs" />
     <Compile Include="Symbolic\Symbols\Constant.cs" />
     <Compile Include="Symbolic\Symbols\ConstantTreeNode.cs" />
+    <Compile Include="Symbolic\Symbols\Division.cs" />
+    <Compile Include="Symbolic\Symbols\Multiplication.cs" />
+    <Compile Include="Symbolic\Symbols\Subtraction.cs" />
     <Compile Include="Symbolic\Symbols\Variable.cs" />
     <Compile Include="Symbolic\Symbols\VariableTreeNode.cs" />
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ArithmeticExpressionGrammar.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ArithmeticExpressionGrammar.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ArithmeticExpressionGrammar.cs	(revision 3462)
@@ -27,5 +27,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Symbols;
 using HeuristicLab.Data;
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols;
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ISymbolicExpressionTreeInterpreter.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ISymbolicExpressionTreeInterpreter.cs	(revision 3462)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/ISymbolicExpressionTreeInterpreter.cs	(revision 3462)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using System.Collections.Generic;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  public interface ISymbolicExpressionTreeInterpreter : IItem {
+    IEnumerable<double> GetSymbolicExpressionTreeValues(SymbolicExpressionTree tree, Dataset dataset, IEnumerable<int> rows);
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionInterpreter.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionInterpreter.cs	(revision 3462)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SimpleArithmeticExpressionInterpreter.cs	(revision 3462)
@@ -0,0 +1,153 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using System.Collections.Generic;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Symbols;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Compiler;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableClass]
+  [Item("SimpleArithmeticExpressionInterpreter", "Interpreter for arithmetic symbolic expression trees including function calls.")]
+  public class SimpleArithmeticExpressionInterpreter : Item, ISymbolicExpressionTreeInterpreter {
+    private class OpCodes {
+      public const byte Add = 1;
+      public const byte Sub = 2;
+      public const byte Mul = 3;
+      public const byte Div = 4;
+      public const byte Variable = 5;
+      public const byte Constant = 6;
+      public const byte Call = 100;
+      public const byte Arg = 101;
+    }
+
+    private Dataset dataset;
+    private int row;
+    private Instruction[] code;
+    private int pc;
+
+    public IEnumerable<double> GetSymbolicExpressionTreeValues(SymbolicExpressionTree tree, Dataset dataset, IEnumerable<int> rows) {
+      this.dataset = dataset;
+      var compiler = new SymbolicExpressionTreeCompiler();
+      compiler.AddInstructionPostProcessingHook(PostProcessInstruction);
+      code = compiler.Compile(tree, MapSymbolToOpCode);
+      foreach (var row in rows) {
+        this.row = row;
+        pc = 0;
+        argumentStack.Clear();
+        var estimatedValue = Evaluate();
+        if (double.IsNaN(estimatedValue) || double.IsInfinity(estimatedValue)) yield return 0.0;
+        else yield return estimatedValue;
+      }
+    }
+
+    private Instruction PostProcessInstruction(Instruction instr) {
+      if (instr.opCode == OpCodes.Variable) {
+        var variableTreeNode = instr.dynamicNode as VariableTreeNode;
+        instr.iArg0 = (ushort)dataset.GetVariableIndex(variableTreeNode.VariableName);
+      }
+      return instr;
+    }
+
+    private byte MapSymbolToOpCode(SymbolicExpressionTreeNode treeNode) {
+      if (treeNode.Symbol is Addition) return OpCodes.Add;
+      if (treeNode.Symbol is Subtraction) return OpCodes.Sub;
+      if (treeNode.Symbol is Multiplication) return OpCodes.Mul;
+      if (treeNode.Symbol is Division) return OpCodes.Div;
+      if (treeNode.Symbol is HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols.Variable) return OpCodes.Variable;
+      if (treeNode.Symbol is Constant) return OpCodes.Constant;
+      if (treeNode.Symbol is InvokeFunction) return OpCodes.Call;
+      if (treeNode.Symbol is Argument) return OpCodes.Arg;
+      throw new NotSupportedException("Symbol: " + treeNode.Symbol);
+    }
+
+    private Stack<List<double>> argumentStack = new Stack<List<double>>();
+    public double Evaluate() {
+      var currentInstr = code[pc++];
+      switch (currentInstr.opCode) {
+        case OpCodes.Add: {
+            double s = 0.0;
+            for (int i = 0; i < currentInstr.nArguments; i++) {
+              s += Evaluate();
+            }
+            return s;
+          }
+        case OpCodes.Sub: {
+            double s = Evaluate();
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              s -= Evaluate();
+            }
+            return s;
+          }
+        case OpCodes.Mul: {
+            double p = Evaluate();
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              p *= Evaluate();
+            }
+            return p;
+          }
+        case OpCodes.Div: {
+            double p = Evaluate();
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              p /= Evaluate();
+            }
+            return p;
+          }
+        case OpCodes.Call: {
+            // save current arguments
+            List<double> arguments = new List<double>();
+            // evaluate sub-trees
+            for (int i = 0; i < currentInstr.nArguments; i++) {
+              arguments.Add(Evaluate());
+            }
+            argumentStack.Push(arguments);
+            // save the pc
+            int nextPc = pc;
+            // set pc to start of function  
+            pc = currentInstr.iArg0;
+            // evaluate the function
+            double v = Evaluate();
+            argumentStack.Pop();
+            // restore the pc => evaluation will continue at point after my subtrees  
+            pc = nextPc;
+            return v;
+          }
+        case OpCodes.Arg: {
+            return argumentStack.Peek()[currentInstr.iArg0];
+          }
+        case OpCodes.Variable: {
+            var variableTreeNode = currentInstr.dynamicNode as VariableTreeNode;
+            return dataset[row, currentInstr.iArg0] * variableTreeNode.Weight;
+          }
+        case OpCodes.Constant: {
+            var constTreeNode = currentInstr.dynamicNode as ConstantTreeNode;
+            return constTreeNode.Value;
+          }
+        default: throw new NotSupportedException();
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SymbolicSimplifier.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SymbolicSimplifier.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/SymbolicSimplifier.cs	(revision 3462)
@@ -25,5 +25,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Symbols;
 using HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols;
 using System.Diagnostics;
@@ -38,4 +38,10 @@
   /// </summary>
   public class SymbolicSimplifier {
+    private Addition addSymbol = new Addition();
+    private Multiplication mulSymbol = new Multiplication();
+    private Division divSymbol = new Division();
+    private Constant constSymbol = new Constant();
+    private Variable varSymbol = new Variable();
+
     public SymbolicExpressionTree Simplify(SymbolicExpressionTree originalTree) {
       var clone = (SymbolicExpressionTreeNode)originalTree.Root.Clone();
@@ -194,5 +200,5 @@
         return a;
       } else {
-        var div = (new Division()).CreateTreeNode();
+        var div = divSymbol.CreateTreeNode();
         div.SubTrees.Add(a);
         div.SubTrees.Add(b);
@@ -215,5 +221,5 @@
       } else if (IsAddition(a) && IsAddition(b)) {
         // merge additions
-        var add = (new Addition()).CreateTreeNode();
+        var add = addSymbol.CreateTreeNode();
         for (int i = 0; i < a.SubTrees.Count - 1; i++) add.AddSubTree(a.SubTrees[i]);
         for (int i = 0; i < b.SubTrees.Count - 1; i++) add.AddSubTree(b.SubTrees[i]);
@@ -232,5 +238,5 @@
         return MakeAddition(b, a);
       } else if (IsAddition(a) && IsConstant(b)) {
-        var add = (new Addition()).CreateTreeNode();
+        var add = addSymbol.CreateTreeNode();
         for (int i = 0; i < a.SubTrees.Count - 1; i++) add.AddSubTree(a.SubTrees[i]);
         if (IsConstant(a.SubTrees.Last()))
@@ -242,5 +248,5 @@
         return add;
       } else if (IsAddition(a)) {
-        var add = (new Addition()).CreateTreeNode();
+        var add = addSymbol.CreateTreeNode();
         add.AddSubTree(b);
         foreach (var subTree in a.SubTrees) {
@@ -250,5 +256,5 @@
         return add;
       } else {
-        var add = (new Addition()).CreateTreeNode();
+        var add = addSymbol.CreateTreeNode();
         add.SubTrees.Add(a);
         add.SubTrees.Add(b);
@@ -296,5 +302,5 @@
         return MakeDivision(MakeMultiplication(b.SubTrees[0], a), b.SubTrees[1]);
       } else if (IsMultiplication(a) && IsMultiplication(b)) {
-        var mul = (new Multiplication()).CreateTreeNode();
+        var mul = mulSymbol.CreateTreeNode();
         for (int i = 0; i < a.SubTrees.Count - 1; i++) mul.AddSubTree(a.SubTrees[i]);
         for (int i = 0; i < b.SubTrees.Count - 1; i++) mul.AddSubTree(b.SubTrees[i]);
@@ -302,15 +308,15 @@
         return mul;
       } else if (IsMultiplication(a)) {
-        var mul = (new Multiplication()).CreateTreeNode();
+        var mul = mulSymbol.CreateTreeNode();
         for (int i = 0; i < a.SubTrees.Count - 1; i++) mul.AddSubTree(a.SubTrees[i]);
         mul.AddSubTree(MakeMultiplication(a.SubTrees.Last(), b));
         return mul;
       } else if (IsMultiplication(b)) {
-        var mul = (new Multiplication()).CreateTreeNode();
+        var mul = mulSymbol.CreateTreeNode();
         for (int i = 0; i < b.SubTrees.Count - 1; i++) mul.AddSubTree(b.SubTrees[i]);
         mul.AddSubTree(MakeMultiplication(b.SubTrees.Last(), a));
         return mul;
       } else {
-        var mul = (new Multiplication()).CreateTreeNode();
+        var mul = mulSymbol.CreateTreeNode();
         mul.SubTrees.Add(a);
         mul.SubTrees.Add(b);
@@ -346,5 +352,5 @@
 
     private SymbolicExpressionTreeNode MakeConstant(double value) {
-      ConstantTreeNode constantTreeNode = (ConstantTreeNode)(new Constant().CreateTreeNode());
+      ConstantTreeNode constantTreeNode = (ConstantTreeNode)(constSymbol.CreateTreeNode());
       constantTreeNode.Value = value;
       return (SymbolicExpressionTreeNode)constantTreeNode;
@@ -352,5 +358,5 @@
 
     private SymbolicExpressionTreeNode MakeVariable(double weight, string name) {
-      var tree = (VariableTreeNode)(new Variable().CreateTreeNode());
+      var tree = (VariableTreeNode)varSymbol.CreateTreeNode();
       tree.Weight = weight;
       tree.VariableName = name;
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/Addition.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/Addition.cs	(revision 3462)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/Addition.cs	(revision 3462)
@@ -0,0 +1,31 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Symbols;
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols {
+  [StorableClass]
+  [Item("Addition", "Symbol that represents the + operator.")]
+  public sealed class Addition : Symbol {
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/Constant.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/Constant.cs	(revision 3461)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/Symbols/Constant.cs	(revision 3462)
@@ -27,4 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Parameters;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Symbols;
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Symbols {
   [StorableClass]
